// Copyright (c) 2023 VMware Carbon Black, all rights reserved

package metrics

import (
	"time"
)

// Service includes metric gathering functions to be called regardless of client impl
type Service interface {
	TrackMethodTime(name string, start time.Time, dims map[string]string)

	Count(name string, dimensions map[string]string, value int64)
	Gauge(name string, dimensions map[string]string, value int64)
	Histogram(name string, dimensions map[string]string, value int64)
	RegisterMetric(name string, metric interface{}, tags map[string]string) error
	StartServer()

	Name() string
}
